# 1 "../mouse_int.S"
# 1 "<built-in>"
# 1 "<command-line>"
# 1 "../mouse_int.S"
|
| Low level and interrupt routines for the USB mouse driver
|
# 36 "../mouse_int.S"
 .globl _vdi_buttons
 .globl _old_vdi_btnv
 .globl _vdi_btnv

_vdi_buttons:
 dc.l 0
 dc.l 0x58425241 | XBRA
 dc.l 0x534d5343 | _USB
_old_vdi_btnv:
 ds.l 1
_vdi_btnv:
 or.l _vdi_buttons(pc), d0 | merge buttons 3-5 with 1-2
 move.l _old_vdi_btnv(pc), -(sp)
 rts

 .globl _send_wheel
 .globl _vdi_wheelv
_vdi_wheelv:
 dc.l simple_rts
_send_wheel:
 move.w 4(sp), d0
 move.w 6(sp), d1
 move.l _vdi_wheelv(pc), -(sp)
simple_rts:
 rts


 .globl _old_trap2
 .globl _trap2
 dc.l 0x58425241 | XBRA
 dc.l 0x534d5343 | _USB
_old_trap2:
 ds.l 1
_trap2:
 cmpi.w #115, d0
 bne.s trap2_call_orig

 move.l a0, -(sp) | save A0
 move.l d1, a0 | VDIPB
 move.l (a0), a0 | VDI contrl





 cmpi.w #125, (a0) | vex_butv

 bne.s test_vex_wheelv







 move.l _old_vdi_btnv(pc), 18(a0)
 move.l 14(a0), _old_vdi_btnv




 move.l (sp)+, a0
 rte

test_vex_wheelv:
# 109 "../mouse_int.S"
 cmpi.w #134, (a0) | vex_wheelv
 bne.s trap2_call_orig_restore_regs
 move.l _vdi_wheelv(pc), 18(a0)
 move.l 14(a0), _vdi_wheelv

trap2_call_orig_restore_regs:



 move.l (sp)+, a0
trap2_call_orig:
 move.l _old_trap2(pc), -(sp)
 rts



 .globl _send_packet
 .globl _fake_hwint

_send_packet:
 lea -60(sp),sp
 movem.l d0-a6,(sp)
 move.l 64(sp),a2
 move.l 68(sp),a0
 move.l 72(sp),a1
 jsr (a2)
 movem.l (sp),d0-a6
 lea 60(sp),sp
 rts


| wake screen saver
_fake_hwint:

 tst.w 0x59e.w
 beq shortframe
 move.w #0x118,-(sp)
shortframe:
 pea retaddr(pc)
 move sr,d0
 move.w d0,-(sp)
 move.l 0x118,a0
 jmp (a0)
retaddr:

 rts

 .bss
lock: ds.w 1
oldSP: ds.l 1
 ds.l 1024
ourSP:
 .end
