# 1 "../usb_mouse.c"
# 1 "<built-in>"
# 1 "<command-line>"
# 1 "../usb_mouse.c"
# 1 "../../../global.h" 1
# 26 "../../../global.h"
# 1 "../../../../../cookie.h" 1
# 13 "../../../../../cookie.h"
# 1 "../../../../../mint/mint.h" 1
# 15 "../../../../../mint/mint.h"
# 1 "../../../../../mint/kernel.h" 1
# 16 "../../../../../mint/mint.h" 2

# 1 "../../../../../mint/kassert.h" 1
# 18 "../../../../../mint/mint.h" 2
# 1 "../../../../../mint/kcompiler.h" 1
# 39 "../../../../../mint/kcompiler.h"
# 1 "c:\\mint-elf\\m68k-atari-mint-elf-8.1.0\\devkitmint\\devkitmint\\m68k-atari-mint\\include\\compiler.h" 1 3
# 149 "c:\\mint-elf\\m68k-atari-mint-elf-8.1.0\\devkitmint\\devkitmint\\m68k-atari-mint\\include\\compiler.h" 3
# 1 "c:\\mint-elf\\m68k-atari-mint-elf-8.1.0\\devkitmint\\devkitmint\\m68k-atari-mint\\include\\linker.h" 1 3
# 150 "c:\\mint-elf\\m68k-atari-mint-elf-8.1.0\\devkitmint\\devkitmint\\m68k-atari-mint\\include\\compiler.h" 2 3
# 159 "c:\\mint-elf\\m68k-atari-mint-elf-8.1.0\\devkitmint\\devkitmint\\m68k-atari-mint\\include\\compiler.h" 3
# 1 "c:\\mint-elf\\m68k-atari-mint-elf-8.1.0\\devkitmint\\devkitmint\\m68k-atari-mint\\include\\features.h" 1 3
# 425 "c:\\mint-elf\\m68k-atari-mint-elf-8.1.0\\devkitmint\\devkitmint\\m68k-atari-mint\\include\\features.h" 3
# 1 "c:\\mint-elf\\m68k-atari-mint-elf-8.1.0\\devkitmint\\devkitmint\\m68k-atari-mint\\include\\sys\\cdefs.h" 1 3
# 426 "c:\\mint-elf\\m68k-atari-mint-elf-8.1.0\\devkitmint\\devkitmint\\m68k-atari-mint\\include\\features.h" 2 3
# 160 "c:\\mint-elf\\m68k-atari-mint-elf-8.1.0\\devkitmint\\devkitmint\\m68k-atari-mint\\include\\compiler.h" 2 3
# 40 "../../../../../mint/kcompiler.h" 2
# 19 "../../../../../mint/mint.h" 2
# 1 "../../../../../mint/ktypes.h" 1
# 22 "../../../../../mint/ktypes.h"
typedef enum { false = (0 == 1), true = (1 == 1) } bool;

typedef unsigned char uchar;
typedef unsigned short ushort;
typedef unsigned long ulong;




typedef long long llong;
typedef unsigned long long ullong;




typedef signed char __s8;
typedef signed short __s16;
typedef signed long __s32;

typedef signed long long __s64;





typedef unsigned char __u8;
typedef unsigned short __u16;
typedef unsigned long __u32;

typedef unsigned long long __u64;





typedef __s8 int8_t;
typedef __s16 int16_t;
typedef __s32 int32_t;
typedef __s64 int64_t;

typedef __u8 u_int8_t;
typedef __u16 u_int16_t;
typedef __u32 u_int32_t;
typedef __u64 u_int64_t;


typedef long (*Func)();



struct dom_ops;
struct iovec;
struct module_callback;
struct proc_ext;
struct sigaction;
struct socket;




typedef struct fcookie fcookie;
typedef struct timeval TIMEVAL;
typedef struct dtabuf DTABUF;
typedef struct dirstruct DIR;
typedef struct xattr XATTR;
typedef struct stat STAT;
typedef struct file FILEPTR;
typedef struct ilock LOCK;
typedef struct filesys FILESYS;
typedef struct devdrv DEVDRV;
typedef struct tty TTY;



struct procwakeup;
typedef struct context CONTEXT;
typedef struct timeout TIMEOUT;
typedef struct proc PROC;



typedef struct bf_key BF_KEY;
typedef struct bdevmap BDEVMAP;
typedef struct dma DMA;
typedef struct pollfd POLLFD;
typedef struct sizebuf SIZEBUF;




typedef enum
{
 machine_unknown,
 machine_st,
 machine_ste,
 machine_megaste,
 machine_tt,
 machine_falcon,
 machine_milan,
 machine_hades,
 machine_ct2,
 machine_ct60,
 machine_firebee




} machine_type;

struct global
{
 machine_type machine;
 long fputype;

 short tosvers;

 short gl_lang;
 short gl_kbd;



 short sysdrv;
 char sysdir[32];
 char mchdir[48];
};


struct bdevmap
{
 long (*instat) (int dev);
 long (*in) (int dev);
 long (*outstat) (int dev);
 long (*out) (int dev, int);
 long (*rsconf) (int dev, int, int, int, int, int, int);
};


struct dma
{
 ulong (*get_channel) (void);
 long (*free_channel) (ulong);
 void (*dma_start) (ulong);
 void (*dma_end) (ulong);
 void * (*block) (ulong, ulong, void (*)(PROC *p, long arg));
 void (*deblock) (ulong, void *);
};

# 1 "../../../../../mint/poll.h" 1
# 36 "../../../../../mint/poll.h"
# 1 "../../../../../mint/ktypes.h" 1
# 37 "../../../../../mint/poll.h" 2



struct pollfd
{
 long fd;
 ushort events;
 ushort revents;
};
# 170 "../../../../../mint/ktypes.h" 2

struct sizebuf
{
 ulong len;
 char buf [0];
};
# 20 "../../../../../mint/mint.h" 2
# 1 "../../../../../mint/errno.h" 1
# 21 "../../../../../mint/mint.h" 2
# 14 "../../../../../cookie.h" 2




struct cookie
{
 long tag;
 long value;
};
# 27 "../../../global.h" 2
# 1 "../../../../../mint/module.h" 1
# 32 "../../../../../mint/module.h"
# 1 "../../../../../mint/mint.h" 1
# 33 "../../../../../mint/module.h" 2
# 1 "../../../../../mint/config.h" 1
# 34 "../../../../../mint/module.h" 2
# 43 "../../../../../mint/module.h"
struct basepage;
struct dirstruct;
struct kentry;

struct km_api
{
 long (*install)(struct kentry *, const char *path);
 long (*uninstall)(void);
};

struct kernel_module
{
 struct kernel_module *next;
 struct kernel_module *prev;
 struct basepage *b;
 short class;
 short subclass;
 unsigned long flags;
 struct km_api *kmapi;
 char path[255];
 char name[64];
 struct proc *caller;
};
# 28 "../../../global.h" 2

# 1 "../../../../../libkern/libkern.h" 1
# 32 "../../../../../libkern/libkern.h"
# 1 "c:\\mint-elf\\m68k-atari-mint-elf-8.1.0\\devkitmint\\devkitmint\\lib\\gcc\\m68k-atari-mint\\8.1.0\\include\\stdarg.h" 1 3 4
# 40 "c:\\mint-elf\\m68k-atari-mint-elf-8.1.0\\devkitmint\\devkitmint\\lib\\gcc\\m68k-atari-mint\\8.1.0\\include\\stdarg.h" 3 4

# 40 "c:\\mint-elf\\m68k-atari-mint-elf-8.1.0\\devkitmint\\devkitmint\\lib\\gcc\\m68k-atari-mint\\8.1.0\\include\\stdarg.h" 3 4
typedef __builtin_va_list __gnuc_va_list;
# 99 "c:\\mint-elf\\m68k-atari-mint-elf-8.1.0\\devkitmint\\devkitmint\\lib\\gcc\\m68k-atari-mint\\8.1.0\\include\\stdarg.h" 3 4
typedef __gnuc_va_list va_list;
# 33 "../../../../../libkern/libkern.h" 2

# 1 "../../../../../mint/kernel.h" 1
# 35 "../../../../../libkern/libkern.h" 2
# 1 "../../../../../mint/kcompiler.h" 1
# 36 "../../../../../libkern/libkern.h" 2
# 1 "../../../../../mint/ktypes.h" 1
# 37 "../../../../../libkern/libkern.h" 2
# 1 "../../../../../mint/basepage.h" 1
# 14 "../../../../../mint/basepage.h"

# 14 "../../../../../mint/basepage.h"
typedef struct basepage BASEPAGE;

struct basepage
{
 long p_lowtpa;
 long p_hitpa;
 long p_tbase;
 long p_tlen;
 long p_dbase;
 long p_dlen;
 long p_bbase;
 long p_blen;
 char *p_dta;
 BASEPAGE *p_parent;
 long p_flags;
 char *p_env;




 char p_devx[6];
 char p_res2;
 char p_defdrv;
 long p_undef[17];
 long p_usp;
 char p_cmdlin[128];
};
# 38 "../../../../../libkern/libkern.h" 2
# 220 "../../../../../libkern/libkern.h"
# 1 "../../../../../libkern/kernel_module.h" 1
# 32 "../../../../../libkern/kernel_module.h"
# 1 "../../../../../mint/kentry.h" 1
# 48 "../../../../../mint/kentry.h"
struct basepage;
struct bio;
struct bpb;
struct businfo;
struct create_process_opts;
struct devinfo;
struct dirstruct;
struct dlong;
struct dma;
struct file;
struct global;
struct ilock;
struct kerinfo;
struct memregion;
struct mfp;
struct module_callback;
struct nf_ops;
struct parser_item;
struct parsinf;
struct pci_conv_adr;
struct scsicmd;
struct scsidrv;
struct semaphore;
struct target;
struct timeout;
struct timeval;
# 122 "../../../../../mint/kentry.h"
struct kentry_mch
{

 const struct global * const global;


 const unsigned long *loops_per_sec;


 const unsigned long *c20ms;


 struct mfp *mfpregs;


 void (*cpush)(const void *base, long size);
 void (*cpushi)(const void *base, long size);


 struct nf_ops *nf_ops;
};
# 157 "../../../../../mint/kentry.h"
struct kentry_proc
{
# 181 "../../../../../mint/kentry.h"
 void (*nap)(unsigned);
 int (*sleep)(int que, long cond);
 void (*wake)(int que, long cond);
 void (*wakeselect)(struct proc *p);







 long (*ikill)(int, unsigned short);
 void (*iwake)(int que, long cond, short pid);

 long (*killgroup)(int, unsigned short, int);
 void (*raise)(unsigned short sig);
# 240 "../../../../../mint/kentry.h"
 struct timeout * (*addtimeout)(long, void (*)(PROC *, long arg));
 void (*canceltimeout)(struct timeout *);
 struct timeout * (*addroottimeout)(long, void (*)(PROC *, long arg), unsigned short);
 void (*cancelroottimeout)(struct timeout *);


 long (*create_process)(const void *ptr1, const void *ptr2, const void *ptr3,
          struct proc **pret, long stack,
          struct create_process_opts *);
# 267 "../../../../../mint/kentry.h"
 long (*kthread_create)(struct proc *p, void (*func)(void *), void *arg,
          struct proc **np, const char *fmt, ...);





 void (*kthread_exit)(short code);


 struct proc * (*get_curproc)(void);
 struct proc * (*pid2proc)(int pid);


 void * (*lookup_extension)(struct proc *p, long ident);
 void * (*attach_extension)(struct proc *p, long ident,
      unsigned long flags, unsigned long size, struct module_callback *);
 void (*detach_extension)(struct proc *p, long ident);


 long (*proc_setuid)(struct proc *p, unsigned short uid);
 long (*proc_setgid)(struct proc *p, unsigned short gid);
};
# 326 "../../../../../mint/kentry.h"
struct kentry_mem
{
# 346 "../../../../../mint/kentry.h"
 void * (*kcore)(unsigned long size, const char *func);
 void * (*kmalloc)(unsigned long size, const char *func);
 void (*kfree)(void *place, const char *func);

 void * (*dmabuf_alloc)(unsigned long size, short cmode, const char *func);

 void * (*umalloc)(unsigned long size, const char *func);
 void (*ufree)(void *place, const char *func);

 struct memregion * (*addr2mem)(struct proc *p, long addr);
 long (*attach_region)(struct proc *proc, struct memregion *reg);
 void (*detach_region)(struct proc *proc, struct memregion *reg);
};
# 378 "../../../../../mint/kentry.h"
struct kentry_fs
{



 unsigned short default_perm;
 unsigned short default_dir_perm;







 void (*_changedrv)(unsigned short drv, const char *function);
# 412 "../../../../../mint/kentry.h"
 int (*denyshare)(struct file *, struct file *);
 LOCK * (*denylock)(ushort pid, struct ilock *, struct ilock *);

 struct bio *bio;
 const struct timeval *xtime;

 long (*kernel_opendir)(struct dirstruct *dirh, const char *name);
 long (*kernel_readdir)(struct dirstruct *dirh, char *buf, int len);
 void (*kernel_closedir)(struct dirstruct *dirh);

 struct file * (*kernel_open)(const char *path, int rwmode, long *err, XATTR *x);
 long (*kernel_read)(struct file *f, void *buf, long buflen);
 long (*kernel_write)(struct file *f, const void *buf, long buflen);
 long (*kernel_lseek)(FILEPTR *f, long where, int whence);
 void (*kernel_close)(struct file *f);

 long (*path2cookie)(struct proc *p, const char *path, char *lastname, fcookie *res);
 long (*relpath2cookie)(struct proc *p, fcookie *relto, const char *path, char *lastname, fcookie *res, int depth);
 void (*release_cookie)(fcookie *fc);
};
# 463 "../../../../../mint/kentry.h"
struct kentry_sockets
{
 void (*so_register)(short, struct dom_ops *);
 void (*so_unregister)(short);
 long (*so_release)(struct socket *);
 void (*so_sockpair)(struct socket *, struct socket *);
 long (*so_connect)(struct socket *, struct socket *, short, short, short);
 long (*so_accept)(struct socket *, struct socket *, short);
 long (*so_create)(struct socket **, short, short, short);
 long (*so_dup)(struct socket **, struct socket *);
 void (*so_free)(struct socket *);
};
# 499 "../../../../../mint/kentry.h"
struct kentry_module
{
# 509 "../../../../../mint/kentry.h"
 void (*load_modules)(const char *path,
        const char *ext,
        long (*loader)(struct basepage *, const char *, short *, short *));
# 524 "../../../../../mint/kentry.h"
 long (*register_trap2)(long (*dispatch)(void *), int mode, int flag, long extra);
};
# 535 "../../../../../mint/kentry.h"
struct kentry_cnf
{
 long (*parse_cnf)(const char *path, struct parser_item *, void *);
 long (*parse_include)(const char *path, struct parsinf *, struct parser_item *);
 void (*parser_msg)(struct parsinf *, const char *msg);
};
# 551 "../../../../../mint/kentry.h"
struct kentry_misc
{

 struct dma *dma;


 long (*get_toscookie)(unsigned long tag, unsigned long *val);

 long (*add_rsvfentry)(char *, char, char);
 long (*del_rsvfentry)(char *);



 unsigned long (*remaining_proc_time)(void);




 long (*trap_1_emu)(short fnum, ...);
 long (*trap_13_emu)(short fnum, ...);
 long (*trap_14_emu)(short fnum, ...);
};
# 591 "../../../../../mint/kentry.h"
struct kentry_debug
{
# 602 "../../../../../mint/kentry.h"
 int *debug_level;
 void (*trace)(const char *, ...);
 void (*debug)(const char *, ...);
 void (*alert)(const char *, ...);
 
# 606 "../../../../../mint/kentry.h" 3
void 
# 606 "../../../../../mint/kentry.h"
               (*fatal)(const char *, ...) 
# 606 "../../../../../mint/kentry.h" 3
                                           __attribute__ ((noreturn))
# 606 "../../../../../mint/kentry.h"
                                                   ;
 void (*force)(const char *, ...);
};
extern int debug_level;
# 623 "../../../../../mint/kentry.h"
struct kentry_libkern
{




 unsigned char *_ctype;

 int (*tolower)(int c);
 int (*toupper)(int c);







 long (*vsprintf)(char *buf, long buflen, const char *fmt, va_list args);
 long (*sprintf)(char *dst, long buflen, const char *fmt, ...);

 char * (*getenv)(struct basepage *bp, const char *var);

 long (*atol)(const char *s);
 long (*strtonumber)(const char *name, long *result, int neg, int zerolead);

 long (*strlen)(const char *s);

 long (*strcmp)(const char *str1, const char *str2);
 long (*strncmp)(const char *str1, const char *str2, long len);

 long (*stricmp)(const char *str1, const char *str2);
 long (*strnicmp)(const char *str1, const char *str2, long len);

 char * (*strcpy)(char *dst, const char *src);
 char * (*strncpy)(char *dst, const char *src, long len);
 void (*strncpy_f)(char *dst, const char *src, long len);

 char * (*strlwr)(char *s);
 char * (*strupr)(char *s);

 char * (*strcat)(char *dst, const char *src);
 char * (*strchr)(const char *s, long charwanted);
 char * (*strrchr)(const char *str, long which);
 char * (*strrev)(char *s);

 char * (*strstr)(const char *s, const char *w);

 long (*strtol)(const char *nptr, char **endptr, long base);
 ulong (*strtoul)(const char *nptr, char **endptr, long base);

 void * (*memchr)(void *s, long search, unsigned long size);
 long (*memcmp)(const void *s1, const void *s2, unsigned long size);
# 697 "../../../../../mint/kentry.h"
 void (*ms_time)(unsigned long ms, short *timeptr);
 void (*unix2calendar)(long tv_sec,
     unsigned short *year, unsigned short *month,
     unsigned short *day, unsigned short *hour,
     unsigned short *minute, unsigned short *second);
 long (*unix2xbios)(long tv_sec);
 long (*dostime)(long tv_sec);
 long (*unixtime)(unsigned short time, unsigned short date);





 void (*blockcpy)(char *dst, const char *src, unsigned long nblocks);
 void (*quickcpy)(void *dst, const void *src, unsigned long nbytes);
 void (*quickswap)(void *dst, void *src, unsigned long nbytes);
 void (*quickzero)(char *place, unsigned long size);

 void * (*memcpy)(void *dst, const void *src, unsigned long nbytes);
 void * (*memset)(void *dst, int ucharfill, unsigned long size);

 void (*bcopy)(const void *src, void *dst, unsigned long nbytes);
 void (*bzero)(void *dst, unsigned long size);
};
# 767 "../../../../../mint/kentry.h"
struct kentry_xfs
{
 void (*block)(FILESYS *fs, ushort dev, const char *func);
 void (*deblock)(FILESYS *fs, ushort dev, const char *func);


 long (*root)(FILESYS *fs, int drv, fcookie *fc);
 long (*lookup)(FILESYS *fs, fcookie *dir, const char *name, fcookie *fc);

 DEVDRV * (*getdev)(FILESYS *fs, fcookie *fc, long *devsp);

 long (*getxattr)(FILESYS *fs, fcookie *fc, XATTR *xattr);

 long (*chattr)(FILESYS *fs, fcookie *fc, int attr);
 long (*chown)(FILESYS *fs, fcookie *fc, int uid, int gid);
 long (*chmode)(FILESYS *fs, fcookie *fc, unsigned mode);

 long (*mkdir)(FILESYS *fs, fcookie *dir, const char *name, unsigned mode);
 long (*rmdir)(FILESYS *fs, fcookie *dir, const char *name);
 long (*creat)(FILESYS *fs, fcookie *dir, const char *name, unsigned mode, int attr, fcookie *fc);
 long (*remove)(FILESYS *fs, fcookie *dir, const char *name);
 long (*getname)(FILESYS *fs, fcookie *root, fcookie *dir, char *buf, int len);
 long (*rename)(FILESYS *fs, fcookie *olddir, char *oldname, fcookie *newdir, const char *newname);

 long (*opendir)(FILESYS *fs, DIR *dirh, int flags);
 long (*readdir)(FILESYS *fs, DIR *dirh, char *nm, int nmlen, fcookie *fc);
 long (*rewinddir)(FILESYS *fs, DIR *dirh);
 long (*closedir)(FILESYS *fs, DIR *dirh);

 long (*pathconf)(FILESYS *fs, fcookie *dir, int which);
 long (*dfree)(FILESYS *fs, fcookie *dir, long *buf);
 long (*writelabel)(FILESYS *fs, fcookie *dir, const char *name);
 long (*readlabel)(FILESYS *fs, fcookie *dir, char *name, int namelen);

 long (*symlink)(FILESYS *fs, fcookie *dir, const char *name, const char *to);
 long (*readlink)(FILESYS *fs, fcookie *fc, char *buf, int len);
 long (*hardlink)(FILESYS *fs, fcookie *fromdir, const char *fromname, fcookie *todir, const char *toname);
 long (*fscntl)(FILESYS *fs, fcookie *dir, const char *name, int cmd, long arg);
 long (*dskchng)(FILESYS *fs, int drv, int mode);

 long (*release)(FILESYS *fs, fcookie *fc);
 long (*dupcookie)(FILESYS *fs, fcookie *dst, fcookie *src);

 long (*mknod)(FILESYS *fs, fcookie *dir, const char *name, ulong mode);
 long (*unmount)(FILESYS *fs, int drv);
 long (*stat64)(FILESYS *fs, fcookie *fc, STAT *stat);
};
# 862 "../../../../../mint/kentry.h"
struct kentry_xdd
{
 long (*open)(FILEPTR *f);
 long (*write)(FILEPTR *f, const char *buf, long bytes);
 long (*read)(FILEPTR *f, char *buf, long bytes);
 long (*lseek)(FILEPTR *f, long where, int whence);
 long (*ioctl)(FILEPTR *f, int mode, void *buf);
 long (*datime)(FILEPTR *f, ushort *timeptr, int rwflag);
 long (*close)(FILEPTR *f, int pid);
};
# 883 "../../../../../mint/kentry.h"
struct kentry_pcibios
{
 unsigned long *pcibios_installed;
 long (*Find_pci_device)(unsigned long id, unsigned short index);
 long (*Find_pci_classcode)(unsigned long class, unsigned short index);
 long (*Read_config_byte)(long handle, unsigned short reg, unsigned char *address);
 long (*Read_config_word)(long handle, unsigned short reg, unsigned short *address);
 long (*Read_config_longword)(long handle, unsigned short reg, unsigned long *address);
 unsigned char (*Fast_read_config_byte)(long handle, unsigned short reg);
 unsigned short (*Fast_read_config_word)(long handle, unsigned short reg);
 unsigned long (*Fast_read_config_longword)(long handle, unsigned short reg);
 long (*Write_config_byte)(long handle, unsigned short reg, unsigned short val);
 long (*Write_config_word)(long handle, unsigned short reg, unsigned short val);
 long (*Write_config_longword)(long handle, unsigned short reg, unsigned long val);
 long (*Hook_interrupt)(long handle, unsigned long *routine, unsigned long *parameter);
 long (*Unhook_interrupt)(long handle);
 long (*Special_cycle)(unsigned short bus, unsigned long data);
 long (*Get_routing)(long handle);
 long (*Set_interrupt)(long handle);
 long (*Get_resource)(long handle);
 long (*Get_card_used)(long handle, unsigned long *address);
 long (*Set_card_used)(long handle, unsigned long *callback);
 long (*Read_mem_byte)(long handle, unsigned long offset, unsigned char *address);
 long (*Read_mem_word)(long handle, unsigned long offset, unsigned short *address);
 long (*Read_mem_longword)(long handle, unsigned long offset, unsigned long *address);
 unsigned char (*Fast_read_mem_byte)(long handle, unsigned long offset);
 unsigned short (*Fast_read_mem_word)(long handle, unsigned long offset);
 unsigned long (*Fast_read_mem_longword)(long handle, unsigned long offset);
 long (*Write_mem_byte)(long handle, unsigned long offset, unsigned short val);
 long (*Write_mem_word)(long handle, unsigned long offset, unsigned short val);
 long (*Write_mem_longword)(long handle, unsigned long offset, unsigned long val);
 long (*Read_io_byte)(long handle, unsigned long offset, unsigned char *address);
 long (*Read_io_word)(long handle, unsigned long offset, unsigned short *address);
 long (*Read_io_longword)(long handle, unsigned long offset, unsigned long *address);
 unsigned char (*Fast_read_io_byte)(long handle, unsigned long offset);
 unsigned short (*Fast_read_io_word)(long handle, unsigned long offset);
 unsigned long (*Fast_read_io_longword)(long handle, unsigned long offset);
 long (*Write_io_byte)(long handle, unsigned long offset, unsigned short val);
 long (*Write_io_word)(long handle, unsigned long offset, unsigned short val);
 long (*Write_io_longword)(long handle, unsigned long offset, unsigned long val);
 long (*Get_machine_id)(void);
 long (*Get_pagesize)(void);
 long (*Virt_to_bus)(long handle, unsigned long address, struct pci_conv_adr *pointer);
 long (*Bus_to_virt)(long handle, unsigned long address, struct pci_conv_adr *pointer);
 long (*Virt_to_phys)(unsigned long address, struct pci_conv_adr *pointer);
 long (*Phys_to_virt)(unsigned long address, struct pci_conv_adr *pointer);
};
# 978 "../../../../../mint/kentry.h"
struct kentry_xhdi
{
long (*XHGetVersion)(void);
long (*XHInqTarget)(ushort major, ushort minor, ulong *block_size, ulong *device_flags, char *product_name);
long (*XHReserve)(ushort major, ushort minor, ushort do_reserve, ushort key);
long (*XHLock)(ushort major, ushort minor, ushort do_lock, ushort key);
long (*XHStop)(ushort major, ushort minor, ushort do_stop, ushort key);
long (*XHEject)(ushort major, ushort minor, ushort do_eject, ushort key);
long (*XHDrvMap)(void);
long (*XHInqDev)(ushort bios_device, ushort *major, ushort *minor, ulong *start_sector, struct bpb *bpb);
long (*XHInqDriver)(ushort bios_device, char *name, char *ver, char *company, ushort *ahdi_version, ushort *maxIPL);
long (*XHNewCookie)(void *newcookie);
long (*XHReadWrite)(ushort major, ushort minor, ushort rwflag, ulong recno, ushort count, void *buf);
long (*XHInqTarget2)(ushort major, ushort minor, ulong *block_size, ulong *device_flags, char *product_name, ushort stringlen);
long (*XHInqDev2)(ushort bios_device, ushort *major, ushort *minor, ulong *start_sector, struct bpb *bpb, ulong *blocks, char *partid);
long (*XHDriverSpecial)(ulong key1, ulong key2, ushort subopcode, void *data);
long (*XHGetCapacity)(ushort major, ushort minor, ulong *blocks, ulong *bs);
long (*XHMediumChanged)(ushort major, ushort minor);
long (*XHMiNTInfo)(ushort opcode, struct kerinfo *data);
long (*XHDOSLimits)(ushort which, ulong limit);
long (*XHLastAccess)(ushort major, ushort minor, ulong *ms);
long (*XHReaccess)(ushort major, ushort minor);
};
# 1025 "../../../../../mint/kentry.h"
struct kentry_scsidrv
{
long (*scsidrv_In)(struct scsicmd *par);
long (*scsidrv_Out)(struct scsicmd *par);
long (*scsidrv_InquireSCSI)(short what, struct businfo *info);
long (*scsidrv_InquireBus)(short what, short BusNo, struct devinfo *dev);
long (*scsidrv_CheckDev)(short BusNo, const struct dlong *SCSIId, char *Name, ushort *Features);
long (*scsidrv_RescanBus)(short BusNo);
long (*scsidrv_Open)(short BusNo, const struct dlong *SCSIId, ulong *MaxLen);
long (*scsidrv_Close)(short *handle);
long (*scsidrv_Error)(short *handle, short rwflag, short ErrNo);
long (*scsidrv_Install)(ushort bus, struct target *handler);
long (*scsidrv_Deinstall)(ushort bus, struct target *handler);
long (*scsidrv_GetCmd)(ushort bus, char *cmd);
long (*scsidrv_SendData)(ushort bus, char *buf, ulong len);
long (*scsidrv_GetData)(ushort bus, void *buf, ulong len);
long (*scsidrv_SendStatus)(ushort bus, ushort status);
long (*scsidrv_SendMsg)(ushort bus, ushort msg);
long (*scsidrv_GetMsg)(ushort bus, ushort *msg);
long (*scsidrv_InstallNewDriver)(struct scsidrv *newdrv);
};
# 1070 "../../../../../mint/kentry.h"
struct kentry
{
 unsigned char major;
 unsigned char minor;
 unsigned char patchlevel;
 unsigned char beta;

 unsigned char version_major;
 unsigned char version_minor;
 unsigned short status;

 unsigned long dos_version;


 Func *vec_dos;
 Func *vec_bios;
 Func *vec_xbios;


 struct kentry_mch vec_mch;
 struct kentry_proc vec_proc;
 struct kentry_mem vec_mem;
 struct kentry_fs vec_fs;
 struct kentry_sockets vec_sockets;
 struct kentry_module vec_module;
 struct kentry_cnf vec_cnf;
 struct kentry_misc vec_misc;
 struct kentry_debug vec_debug;
 struct kentry_libkern vec_libkern;

 struct kentry_xfs vec_xfs;
 struct kentry_xdd vec_xdd;

 struct kentry_pcibios vec_pcibios;
 struct kentry_xhdi vec_xhdi;
 struct kentry_scsidrv vec_scsidrv;
};
# 33 "../../../../../libkern/kernel_module.h" 2
# 1 "../../../../../buildinfo/version.h" 1
# 34 "../../../../../libkern/kernel_module.h" 2
# 47 "../../../../../libkern/kernel_module.h"
extern struct kentry *kentry;
# 489 "../../../../../libkern/kernel_module.h"
static __inline __attribute__ ((__always_inline__)) long c_conws(const char *str)
{ return ((long (*)(const char *)) (*kentry->vec_dos[0x009]))(str); }

static __inline __attribute__ ((__always_inline__)) long c_conout(const int c)
{ return ((long (*)(const int)) (*kentry->vec_dos[0x002]))(c); }

static __inline __attribute__ ((__always_inline__)) long d_setdrv(int drv)
{ return ((long (*)(int)) (*kentry->vec_dos[0x00e]))(drv); }

static __inline __attribute__ ((__always_inline__)) long d_getdrv(void)
{ return ((long (*)(void)) (*kentry->vec_dos[0x019]))(); }

static __inline __attribute__ ((__always_inline__)) long f_setdta(DTABUF *dta)
{ return ((long (*)(DTABUF *)) (*kentry->vec_dos[0x01a]))(dta); }

static __inline __attribute__ ((__always_inline__)) long t_getdate(void)
{ return ((long (*)(void)) (*kentry->vec_dos[0x02a]))(); }

static __inline __attribute__ ((__always_inline__)) long t_gettime(void)
{ return ((long (*)(void)) (*kentry->vec_dos[0x02c]))(); }

static __inline __attribute__ ((__always_inline__)) long f_getdta(void)
{ return ((long (*)(void)) (*kentry->vec_dos[0x02f]))(); }

static __inline __attribute__ ((__always_inline__)) long d_setpath(const char *path)
{ return ((long (*)(const char *)) (*kentry->vec_dos[0x03b]))(path); }

static __inline __attribute__ ((__always_inline__)) long f_create(const char *name, int attrib)
{ return ((long (*)(const char *, int)) (*kentry->vec_dos[0x03c]))(name, attrib); }

static __inline __attribute__ ((__always_inline__)) long f_open(const char *name, int mode)
{ return ((long (*)(const char *, int)) (*kentry->vec_dos[0x03d]))(name, mode); }

static __inline __attribute__ ((__always_inline__)) long f_close(int fh)
{ return ((long (*)(int)) (*kentry->vec_dos[0x03e]))(fh); }

static __inline __attribute__ ((__always_inline__)) long f_read(int fh, long count, void *buf)
{ return ((long (*)(int, long, void *)) (*kentry->vec_dos[0x03f]))(fh, count, buf); }

static __inline __attribute__ ((__always_inline__)) long f_write(int fh, long count, const void *buf)
{ return ((long (*)(int, long, const void *)) (*kentry->vec_dos[0x040]))(fh, count, buf); }

static __inline __attribute__ ((__always_inline__)) long d_getpath(char *path, int drv)
{ return ((long (*)(char *, int)) (*kentry->vec_dos[0x047]))(path, drv); }

static __inline __attribute__ ((__always_inline__)) long m_xalloc(long size, int mode)
{ return ((long (*)(long, int)) (*kentry->vec_dos[0x044]))(size, mode); }

static __inline __attribute__ ((__always_inline__)) long f_dup(short fd)
{ return ((long (*)(short)) (*kentry->vec_dos[0x045]))(fd); }

static __inline __attribute__ ((__always_inline__)) long m_alloc(long size)
{ return ((long (*)(long)) (*kentry->vec_dos[0x048]))(size); }

static __inline __attribute__ ((__always_inline__)) long m_free(void *block)
{ return ((long (*)(void *)) (*kentry->vec_dos[0x049]))(block); }

static __inline __attribute__ ((__always_inline__)) long m_shrink(int dummy, long block, long size)
{ return ((long (*)(int, long, long)) (*kentry->vec_dos[0x04a]))(dummy, block, size); }

static __inline __attribute__ ((__always_inline__)) long p_exec(int mode, const void *ptr1, const void *ptr2, const void *ptr3)
{ return ((long (*)(int, const void *, const void *, const void *)) (*kentry->vec_dos[0x04b]))(mode, ptr1, ptr2, ptr3); }

static __inline __attribute__ ((__always_inline__)) long p_term(int code)
{ return ((long (*)(int)) (*kentry->vec_dos[0x04c]))(code); }

static __inline __attribute__ ((__always_inline__)) long f_sfirst(const char *path, int attrib)
{ return ((long (*)(const char *, int)) (*kentry->vec_dos[0x04e]))(path, attrib); }

static __inline __attribute__ ((__always_inline__)) long f_snext(void)
{ return ((long (*)(void)) (*kentry->vec_dos[0x04f]))(); }

static __inline __attribute__ ((__always_inline__)) long s_yield(void)
{ return ((long (*)(void)) (*kentry->vec_dos[0x0ff]))(); }

static __inline __attribute__ ((__always_inline__)) long f_cntl(int fh, long arg, int cmd)
{ return ((long (*)(int, long, int)) (*kentry->vec_dos[0x104]))(fh, arg, cmd); }

static __inline __attribute__ ((__always_inline__)) long f_instat(int fh)
{ return ((long (*)(int)) (*kentry->vec_dos[0x105]))(fh); }

static __inline __attribute__ ((__always_inline__)) long f_getchar(int fh, int mode)
{ return ((long (*)(int, int)) (*kentry->vec_dos[0x107]))(fh, mode); }

static __inline __attribute__ ((__always_inline__)) long p_nice(int increment)
{ return ((long (*)(int)) (*kentry->vec_dos[0x10a]))(increment); }

static __inline __attribute__ ((__always_inline__)) long p_getpid(void)
{ return ((long (*)(void)) (*kentry->vec_dos[0x10b]))(); }

static __inline __attribute__ ((__always_inline__)) long p_getppid(void)
{ return ((long (*)(void)) (*kentry->vec_dos[0x10c]))(); }

static __inline __attribute__ ((__always_inline__)) long p_getpgrp(void)
{ return ((long (*)(void)) (*kentry->vec_dos[0x10d]))(); }

static __inline __attribute__ ((__always_inline__)) long p_setpgrp(int pid, int newgrp)
{ return ((long (*)(int, int)) (*kentry->vec_dos[0x10e]))(pid, newgrp); }

static __inline __attribute__ ((__always_inline__)) long p_getuid(void)
{ return ((long (*)(void)) (*kentry->vec_dos[0x10f]))(); }

static __inline __attribute__ ((__always_inline__)) long p_setuid(int id)
{ return ((long (*)(int)) (*kentry->vec_dos[0x110]))(id); }

static __inline __attribute__ ((__always_inline__)) long p_kill(int pid, int sig)
{ return ((long (*)(int, int)) (*kentry->vec_dos[0x111]))(pid, sig); }

static __inline __attribute__ ((__always_inline__)) long p_signal(short sig, long handler)
{ return ((long (*)(short, long)) (*kentry->vec_dos[0x112]))(sig, handler); }

static __inline __attribute__ ((__always_inline__)) long p_getgid(void)
{ return ((long (*)(void)) (*kentry->vec_dos[0x114]))(); }

static __inline __attribute__ ((__always_inline__)) long p_setgid(int id)
{ return ((long (*)(int)) (*kentry->vec_dos[0x115]))(id); }

static __inline __attribute__ ((__always_inline__)) long p_sigblock(unsigned long mask)
{ return ((long (*)(unsigned long)) (*kentry->vec_dos[0x116]))(mask); }

static __inline __attribute__ ((__always_inline__)) long p_sigsetmask(unsigned long mask)
{ return ((long (*)(unsigned long)) (*kentry->vec_dos[0x117]))(mask); }

static __inline __attribute__ ((__always_inline__)) long p_domain(int arg)
{ return ((long (*)(int)) (*kentry->vec_dos[0x119]))(arg); }

static __inline __attribute__ ((__always_inline__)) long f_select(unsigned timeout, long *rfdp, long *wfdp, long *xfdp)
{ return ((long (*)(unsigned, long *, long *, long *)) (*kentry->vec_dos[0x11d]))(timeout, rfdp, wfdp, xfdp); }

static __inline __attribute__ ((__always_inline__)) long p_setlimit(int i, long v)
{ return ((long (*)(int, long)) (*kentry->vec_dos[0x11f]))(i, v); }

static __inline __attribute__ ((__always_inline__)) long s_ysconf(int which)
{ return ((long (*)(int)) (*kentry->vec_dos[0x122]))(which); }

static __inline __attribute__ ((__always_inline__)) long d_pathconf(const char *name, int which)
{ return ((long (*)(const char *, int)) (*kentry->vec_dos[0x124]))(name, which); }

static __inline __attribute__ ((__always_inline__)) long p_msg(int mode, long mbid, char *ptr)
{ return ((long (*)(int, long, char *)) (*kentry->vec_dos[0x125]))(mode, mbid, ptr); }

static __inline __attribute__ ((__always_inline__)) long p_renice(int pid, int increment)
{ return ((long (*)(int, int)) (*kentry->vec_dos[0x127]))(pid, increment); }

static __inline __attribute__ ((__always_inline__)) long d_opendir(const char *path, int flags)
{ return ((long (*)(const char *, int)) (*kentry->vec_dos[0x128]))(path, flags); }

static __inline __attribute__ ((__always_inline__)) long d_readdir(int len, long handle, char *buf)
{ return ((long (*)(int, long, char *)) (*kentry->vec_dos[0x129]))(len, handle, buf); }

static __inline __attribute__ ((__always_inline__)) long d_closedir(long handle)
{ return ((long (*)(long)) (*kentry->vec_dos[0x12b]))(handle); }

static __inline __attribute__ ((__always_inline__)) long f_xattr(int flag, const char *name, XATTR *xattr)
{ return ((long (*)(int, const char *, XATTR *)) (*kentry->vec_dos[0x12c]))(flag, name, xattr); }

static __inline __attribute__ ((__always_inline__)) long d_cntl(int cmd, const char *name, long arg)
{ return ((long (*)(int, const char *, long)) (*kentry->vec_dos[0x130]))(cmd, name, arg); }

static __inline __attribute__ ((__always_inline__)) long f_chown(const char *name, int uid, int gid)
{ return ((long (*)(const char *, int, int)) (*kentry->vec_dos[0x131]))(name, uid, gid); }

static __inline __attribute__ ((__always_inline__)) long f_chmod(const char *name, unsigned mode)
{ return ((long (*)(const char *, unsigned)) (*kentry->vec_dos[0x132]))(name, mode); }

static __inline __attribute__ ((__always_inline__)) long p_semaphore(int mode, long id, long timeout)
{ return ((long (*)(int, long, long)) (*kentry->vec_dos[0x134]))(mode, id, timeout); }

static __inline __attribute__ ((__always_inline__)) long d_lock(int mode, int drv)
{ return ((long (*)(int, int)) (*kentry->vec_dos[0x135]))(mode, drv); }

static __inline __attribute__ ((__always_inline__)) long p_sigaction(short sig, const struct sigaction *act, struct sigaction *oact)
{ return ((long (*)(short, const struct sigaction *, struct sigaction *)) (*kentry->vec_dos[0x137]))(sig, act, oact); }

static __inline __attribute__ ((__always_inline__)) long p_geteuid(void)
{ return ((long (*)(void)) (*kentry->vec_dos[0x138]))(); }

static __inline __attribute__ ((__always_inline__)) long p_getegid(void)
{ return ((long (*)(void)) (*kentry->vec_dos[0x139]))(); }

static __inline __attribute__ ((__always_inline__)) long p_waitpid(int pid, int nohang, long *rusage)
{ return ((long (*)(int, int, long *)) (*kentry->vec_dos[0x13a]))(pid, nohang, rusage); }

static __inline __attribute__ ((__always_inline__)) long d_getcwd(char *path, int drv, int size)
{ return ((long (*)(char *, int, int)) (*kentry->vec_dos[0x13b]))(path, drv, size); }

static __inline __attribute__ ((__always_inline__)) long d_xreaddir(int len, long handle, char *buf, XATTR *xattr, long *xret)
{ return ((long (*)(int, long, char *, XATTR *, long *)) (*kentry->vec_dos[0x142]))(len, handle, buf, xattr, xret); }

static __inline __attribute__ ((__always_inline__)) long p_seteuid(int id)
{ return ((long (*)(int)) (*kentry->vec_dos[0x143]))(id); }

static __inline __attribute__ ((__always_inline__)) long p_setegid(int id)
{ return ((long (*)(int)) (*kentry->vec_dos[0x144]))(id); }

static __inline __attribute__ ((__always_inline__)) long p_getauid(void)
{ return ((long (*)(void)) (*kentry->vec_dos[0x145]))(); }

static __inline __attribute__ ((__always_inline__)) long p_setauid(int id)
{ return ((long (*)(int)) (*kentry->vec_dos[0x146]))(id); }

static __inline __attribute__ ((__always_inline__)) long p_getgroups(int gidsetlen, int gidset[])
{ return ((long (*)(int, int [])) (*kentry->vec_dos[0x147]))(gidsetlen, gidset); }

static __inline __attribute__ ((__always_inline__)) long p_setgroups(int ngroups, int gidset[])
{ return ((long (*)(int, int [])) (*kentry->vec_dos[0x148]))(ngroups, gidset); }

static __inline __attribute__ ((__always_inline__)) long f_stat64(int flag, const char *name, struct stat *st)
{ return ((long (*)(int, const char *, struct stat *)) (*kentry->vec_dos[0x14b]))(flag, name, st); }

static __inline __attribute__ ((__always_inline__)) long p_setreuid(int rid, int eid)
{ return ((long (*)(int, int)) (*kentry->vec_dos[0x14e]))(rid, eid); }

static __inline __attribute__ ((__always_inline__)) long p_setregid(int rid, int eid)
{ return ((long (*)(int, int)) (*kentry->vec_dos[0x14f]))(rid, eid); }

static __inline __attribute__ ((__always_inline__)) long s_ync(void)
{ return ((long (*)(void)) (*kentry->vec_dos[0x150]))(); }

static __inline __attribute__ ((__always_inline__)) long s_hutdown(long restart)
{ return ((long (*)(long)) (*kentry->vec_dos[0x151]))(restart); }

static __inline __attribute__ ((__always_inline__)) long s_system(int mode, unsigned long arg1, unsigned long arg2)
{ return ((long (*)(int, unsigned long, unsigned long)) (*kentry->vec_dos[0x154]))(mode, arg1, arg2); }

static __inline __attribute__ ((__always_inline__)) long p_getpriority(int which, int who)
{ return ((long (*)(int, int)) (*kentry->vec_dos[0x158]))(which, who); }

static __inline __attribute__ ((__always_inline__)) long p_setpriority(int which, int who, int prio)
{ return ((long (*)(int, int, int)) (*kentry->vec_dos[0x159]))(which, who, prio); }

static __inline __attribute__ ((__always_inline__)) long p_sysctl(long *name, unsigned long namelen, void *old, unsigned long *oldlenp, const void *new, unsigned long newlen)
{ return ((long (*)(long *, unsigned long, void *, unsigned long *, const void *, unsigned long)) (*kentry->vec_dos[0x15e]))(name, namelen, old, oldlenp, new, newlen); }
# 740 "../../../../../libkern/kernel_module.h"
static __inline __attribute__ ((__always_inline__)) long b_ubconin(int dev)
{ return ((long (*)(int)) (*kentry->vec_bios[0x002]))(dev); }

static __inline __attribute__ ((__always_inline__)) long b_ubconout(short dev, short c)
{ return ((long (*)(short, short)) (*kentry->vec_bios[0x003]))(dev, c); }

static __inline __attribute__ ((__always_inline__)) long b_setexc(short number, long vector)
{ return ((long (*)(short, long)) (*kentry->vec_bios[0x005]))(number, vector); }

static __inline __attribute__ ((__always_inline__)) long b_drvmap(void)
{ return ((long (*)(void)) (*kentry->vec_bios[0x00a]))(); }

# 1 "../../../../../libkern/strings.h" 1
extern char *kstrings[];

enum{
 Wrong_FreeMiNT = 0,
 This_module_is_compiled_against,
 MINT_VERS,
 KSTR_NL,
 Wrong_kentry,
 high,
 low
};
# 753 "../../../../../libkern/kernel_module.h" 2




static __inline __attribute__ ((__always_inline__)) long
check_kentry_version(void)
{
 if (((kentry->major) != 1) || ((kentry->minor) != 19))
 {
  c_conws(kstrings[Wrong_FreeMiNT]);
  c_conws(kstrings[This_module_is_compiled_against]);
  c_conws(kstrings[MINT_VERS]);
  c_conws(kstrings[KSTR_NL]);
  return -1;
 }
 if ((kentry->version_major != 0) || (kentry->version_minor != 21))
 {
  int s = 0;
  c_conws(kstrings[Wrong_kentry]);

  if (kentry->version_major == 0)
  {
   if( kentry->version_minor > 21)
    s = 1;
  }
  else
   if (kentry->version_major > 0)
    s = 2;
  if( s )
   c_conws(kstrings[high]);
  else
   c_conws(kstrings[low]);
  c_conws(kstrings[KSTR_NL]);
  return -1;
 }
 return 0;
}
# 1112 "../../../../../libkern/kernel_module.h"
typedef long (*wrap0)();
typedef long (*wrap1)(long);
typedef long (*wrap2)(long, long);
typedef long (*wrap3)(long, long, long);

static __inline __attribute__ ((__always_inline__)) long Find_pci_device(unsigned long id, unsigned short index)
{ wrap2 f = (wrap2) (*kentry->vec_pcibios.Find_pci_device); return (*f)(id, index); }

static __inline __attribute__ ((__always_inline__)) long Find_pci_classcode(unsigned long class, unsigned short index)
{ wrap2 f = (wrap2) (*kentry->vec_pcibios.Find_pci_classcode); return (*f)(class, index); }

static __inline __attribute__ ((__always_inline__)) long Read_config_byte(long handle, unsigned short reg, unsigned char *address)
{ wrap3 f = (wrap3)(*kentry->vec_pcibios.Read_config_byte); return (*f)(handle, reg, (long)address); }

static __inline __attribute__ ((__always_inline__)) long Read_config_word(long handle, unsigned short reg, unsigned short *address)
{ wrap3 f = (wrap3)(*kentry->vec_pcibios.Read_config_word); return (*f)(handle, reg, (long)address); }

static __inline __attribute__ ((__always_inline__)) long Read_config_longword(long handle, unsigned short reg, unsigned long *address)
{ wrap3 f = (wrap3)(*kentry->vec_pcibios.Read_config_longword); return (*f)(handle, reg, (long)address); }

static __inline __attribute__ ((__always_inline__)) unsigned char Fast_read_config_byte(long handle, unsigned short reg)
{ wrap2 f = (wrap2) (*kentry->vec_pcibios.Fast_read_config_byte); return (*f)(handle, reg); }

static __inline __attribute__ ((__always_inline__)) unsigned short Fast_read_config_word(long handle, unsigned short reg)
{ wrap2 f = (wrap2) (*kentry->vec_pcibios.Fast_read_config_word); return (*f)(handle, reg); }

static __inline __attribute__ ((__always_inline__)) unsigned long Fast_read_config_longword(long handle, unsigned short reg)
{ wrap2 f = (wrap2) (*kentry->vec_pcibios.Fast_read_config_longword); return (*f)(handle, reg); }

static __inline __attribute__ ((__always_inline__)) long Special_cycle(unsigned short bus, unsigned long data)
{ wrap2 f = (wrap2) (*kentry->vec_pcibios.Special_cycle); return (*f)(bus, data); }

static __inline __attribute__ ((__always_inline__)) long Write_mem_byte(long handle, unsigned long offset, unsigned short val)
{ wrap3 f = (wrap3)(*kentry->vec_pcibios.Write_mem_byte); return (*f)(handle, offset, val); }

static __inline __attribute__ ((__always_inline__)) long Write_mem_word(long handle, unsigned long offset, unsigned short val)
{ wrap3 f = (wrap3)(*kentry->vec_pcibios.Write_mem_word); return (*f)(handle, offset, val); }

static __inline __attribute__ ((__always_inline__)) long Write_io_byte(long handle, unsigned long offset, unsigned short val)
{ wrap3 f = (wrap3)(*kentry->vec_pcibios.Write_io_byte); return (*f)(handle, offset, val); }

static __inline __attribute__ ((__always_inline__)) long Write_io_word(long handle, unsigned long offset, unsigned short val)
{ wrap3 f = (wrap3)(*kentry->vec_pcibios.Write_io_word); return (*f)(handle, offset, val); }
# 221 "../../../../../libkern/libkern.h" 2


void unaligned_putl(char *addr, long value);
# 30 "../../../global.h" 2

typedef char Path[255];
# 216 "../../../global.h"
static inline void hex_nybble(int n)
{
 char c;

 c = (n > 9) ? 'A'+n-10 : '0'+n;
 c_conout(c);
}

static inline void hex_byte(uchar n)
{
 hex_nybble(n>>4);
 hex_nybble(n&0x0f);
}

static inline void hex_word(ushort n)
{
 hex_byte(n>>8);
 hex_byte(n&0xff);
}

static inline void hex_long(ulong n)
{
 hex_word(n>>16);
 hex_word(n&0xffff);
};
# 2 "../usb_mouse.c" 2

# 1 "../../../usb.h" 1
# 30 "../../../usb.h"
# 1 "../../../usb_defs.h" 1
# 82 "../../../usb_defs.h"
enum usb_device_speed {
  USB_SPEED_UNKNOWN = 0,
  USB_SPEED_LOW, USB_SPEED_FULL,
  USB_SPEED_HIGH,
  USB_SPEED_WIRELESS,
  USB_SPEED_SUPER,
};
# 31 "../../../usb.h" 2
# 53 "../../../usb.h"
struct usb_string_descriptor
{
 unsigned char bLength;
 unsigned char bDescriptorType;
 unsigned short wData[1];
} __attribute__ ((packed));


struct devrequest
{
 unsigned char requesttype;
 unsigned char request;
 unsigned short value;
 unsigned short index;
 unsigned short length;
} __attribute__ ((packed));


struct usb_descriptor_header
{
 unsigned char bLength;
 unsigned char bDescriptorType;
} __attribute__ ((packed));


struct usb_device_descriptor
{
 unsigned char bLength;
 unsigned char bDescriptorType;
 unsigned short bcdUSB;
 unsigned char bDeviceClass;
 unsigned char bDeviceSubClass;
 unsigned char bDeviceProtocol;
 unsigned char bMaxPacketSize0;
 unsigned short idVendor;
 unsigned short idProduct;
 unsigned short bcdDevice;
 unsigned char iManufacturer;
 unsigned char iProduct;
 unsigned char iSerialNumber;
 unsigned char bNumConfigurations;
} __attribute__ ((packed));


struct usb_endpoint_descriptor
{
 unsigned char bLength;
 unsigned char bDescriptorType;
 unsigned char bEndpointAddress;
 unsigned char bmAttributes;
 unsigned short wMaxPacketSize;
 unsigned char bInterval;
 unsigned char bRefresh;
 unsigned char bSynchAddress;
} __attribute__ ((packed)) __attribute__ ((aligned(2)));


struct usb_interface_descriptor
{
 unsigned char bLength;
 unsigned char bDescriptorType;
 unsigned char bInterfaceNumber;
 unsigned char bAlternateSetting;
 unsigned char bNumEndpoints;
 unsigned char bInterfaceClass;
 unsigned char bInterfaceSubClass;
 unsigned char bInterfaceProtocol;
 unsigned char iInterface;
} __attribute__ ((packed));


struct usb_ss_ep_comp_descriptor {
 unsigned char bLength;
 unsigned char bDescriptorType;

 unsigned char bMaxBurst;
 unsigned char bmAttributes;
 unsigned short wBytesPerInterval;
} __attribute__ ((packed));



struct usb_interface {
 struct usb_interface_descriptor desc;
 struct uddif *driver;
 unsigned char no_of_ep;
 unsigned char num_altsetting;
 unsigned char act_altsetting;

 struct usb_endpoint_descriptor ep_desc[16];





 struct usb_ss_ep_comp_descriptor ss_ep_comp_desc[16];
};


struct usb_config_descriptor
{
 unsigned char bLength;
 unsigned char bDescriptorType;
 unsigned short wTotalLength;
 unsigned char bNumInterfaces;
 unsigned char bConfigurationValue;
 unsigned char iConfiguration;
 unsigned char bmAttributes;
 unsigned char bMaxPower;
} __attribute__ ((packed));

struct usb_config {
 struct usb_config_descriptor desc;

 unsigned char no_of_if;
 struct usb_interface if_desc[8];
} __attribute__ ((packed));

enum {

 PACKET_SIZE_8 = 0,
 PACKET_SIZE_16 = 1,
 PACKET_SIZE_32 = 2,
 PACKET_SIZE_64 = 3,
};

struct usb_device;

struct usb_device
{
 long devnum;
 long speed;
 char mf[32];
 char prod[32];
 char serial[32];


 long maxpacketsize;

 unsigned long toggle[2];



 unsigned long halted[2];
 long epmaxpacketin[16];
 long epmaxpacketout[16];

 long configno;
 struct usb_device_descriptor descriptor;
 struct usb_config config;

 long have_langid;
 long string_langid;
 long (*irq_handle)(struct usb_device *dev);
 unsigned long irq_status;
 long irq_act_len;
 void *privptr;




 unsigned long status;
 long act_len;
 long maxchild;
 long portnr;
 struct usb_device *parent;
 struct usb_device *children[8];

 struct ucdif *controller;

};






long usb_lowlevel_init (void *ucd_priv);
long usb_lowlevel_stop (void *ucd_priv);


void usb_main (void);
void usb_init (void);
void usb_stop (void);


long usb_set_protocol (struct usb_device *dev, long ifnum, long protocol);
long usb_set_idle (struct usb_device *dev, long ifnum, long duration,
      long report_id);
long usb_control_msg (struct usb_device *dev, unsigned long pipe,
     unsigned char request, unsigned char requesttype,
     unsigned short value, unsigned short idx,
     void *data, unsigned short size, long timeout);




long usb_bulk_msg (struct usb_device *dev, unsigned long pipe,
     void *data, long len, long *actual_length, long timeout,
     long flags);
long usb_submit_int_msg (struct usb_device *dev, unsigned long pipe,
     void *buffer, long transfer_len, long interval);
long usb_disable_asynch (long disable);
long usb_maxpacket (struct usb_device *dev, unsigned long pipe);
long usb_get_configuration_no(struct usb_device *dev, long cfgno);
long usb_get_report (struct usb_device *dev, long ifnum, unsigned char type,
     unsigned char id, void *buf, long size);
long usb_get_class_descriptor(struct usb_device *dev, long ifnum,
     unsigned char type, unsigned char id, void *buf,
     long size);
long usb_clear_halt (struct usb_device *dev, long pipe);
long usb_string (struct usb_device *dev, long idx, char *buf, long size);
long usb_set_interface (struct usb_device *dev, long interface, long alternate);
struct usb_device * usb_get_dev_index (long idx);
long usb_parse_config (struct usb_device *dev, unsigned char *buffer, long cfgno);
long usb_set_maxpacket (struct usb_device *dev);
long usb_get_descriptor (struct usb_device *dev, unsigned char type,
     unsigned char idx, void *buf, long size);
long usb_set_address (struct usb_device *dev);
long usb_set_configuration (struct usb_device *dev, long configuration);
long usb_get_string (struct usb_device *dev, unsigned short langid,
        unsigned char idx, void *buf, long size);
struct usb_device * usb_alloc_new_device(void *controller);
void usb_free_device (long idx);
long usb_new_device (struct usb_device *dev);
void usb_disconnect (struct usb_device *pdev);

long usb_find_interface_driver(struct usb_device *dev, unsigned ifnum);
# 4 "../usb_mouse.c" 2
# 1 "../../../usb_api.h" 1
# 23 "../../../usb_api.h"
# 1 "../../../usb.h" 1
# 24 "../../../usb_api.h" 2
# 1 "../../../hub.h" 1
# 33 "../../../hub.h"
struct usb_port_status
{
 unsigned short wPortStatus;
 unsigned short wPortChange;
};

struct usb_hub_status
{
 unsigned short wHubStatus;
 unsigned short wHubChange;
};



struct usb_hub_descriptor
{
 unsigned char bLength;
 unsigned char bDescriptorType;
 unsigned char bNbrPorts;
 unsigned short wHubCharacteristics;
 unsigned char bPwrOn2PwrGood;
 unsigned char bHubContrCurrent;
 unsigned char DeviceRemovable[(8 +1+7)/8];
 unsigned char PortPowerCtrlMask[(8 +1+7)/8];


};


struct usb_hub_device
{
 struct usb_device *pusb_dev;
 struct usb_hub_descriptor desc;
};


long usb_get_hub_descriptor (struct usb_device *dev, void *data, long size);
long usb_clear_port_feature (struct usb_device *dev, long port, long feature);
long usb_clear_hub_feature (struct usb_device *dev, long feature);
long usb_get_hub_status (struct usb_device *dev, void *data);
long usb_set_port_feature (struct usb_device *dev, long port, long feature);
long usb_get_port_status (struct usb_device *dev, long port, void *data);
struct usb_hub_device * usb_get_hub_index (long idx);
struct usb_hub_device * usb_hub_allocate(void);
long usb_hub_events (struct usb_hub_device *);
void usb_hub_disconnect (struct usb_device *dev);
long usb_hub_port_connect_change (struct usb_device *dev, long port, unsigned short portstatus);
struct usb_hub_device * usb_hub_configure (struct usb_device *dev);
long usb_hub_probe (struct usb_device *dev, long ifnum);
void usb_hub_reset (void);
long hub_port_reset (struct usb_device *dev, long port);
void usb_rh_wakeup (void);
void usb_hub_init (struct usb_device *);
void usb_hub_thread (void *);
void usb_hub_poll (PROC *, long);
void usb_hub_poll_thread (void *);
# 25 "../../../usb_api.h" 2
# 48 "../../../usb_api.h"
struct bulk_msg
{
 struct usb_device *dev;
 unsigned long pipe;
 void *data;
 long len;
 long flags;
};

struct control_msg
{
 struct usb_device *dev;
 unsigned long pipe;
 unsigned short value;
 void *data;
 unsigned short size;
 struct devrequest *setup;
};

struct int_msg
{
 struct usb_device *dev;
 unsigned long pipe;
 void *buffer;
 long transfer_len;
 long interval;
};

struct ucdif
{
 struct ucdif *next;

 long api_version;

 long class;
 char *lname;
 char name[16];
 short unit;

 unsigned short flags;

 long (*open) (struct ucdif *);
 long (*close) (struct ucdif *);
 long resrvd1;
 long (*ioctl) (struct ucdif *, short cmd, long arg);
 long resrvd2;
 long *ucd_priv;
};
# 106 "../../../usb_api.h"
struct uddif
{
 struct uddif *next;

 long api_version;

 long class;
 char *lname;
 char name[16];
 short unit;

 unsigned short flags;

 long (*probe) (struct usb_device *, unsigned int ifnum);
 long (*disconnect) (struct usb_device *);
 long resrvd1;
 long (*ioctl) (struct uddif *, short cmd, long arg);
 long resrvd2;
};

struct usb_module_api
{

 long api_version;
 long max_devices;
 long max_hubs;


 long (*udd_register) (struct uddif *);
 long (*udd_unregister) (struct uddif *);
 long (*ucd_register) (struct ucdif *, struct usb_device **);
 long (*ucd_unregister) (struct ucdif *);

 void (*usb_rh_wakeup) (void);
 long (*usb_hub_events) (struct usb_hub_device *dev);
 long (*usb_set_protocol) (struct usb_device *dev, long ifnum, long protocol);
 long (*usb_set_idle) (struct usb_device *dev, long ifnum, long duration,
        long report_id);
 struct usb_device * (*usb_get_dev_index) (long idx);
 struct usb_hub_device * (*usb_get_hub_index) (long idx);
 long (*usb_control_msg) (struct usb_device *dev, unsigned long pipe,
        unsigned char request, unsigned char requesttype,
        unsigned short value, unsigned short idx,
        void *data, unsigned short size, long timeout);
 long (*usb_bulk_msg) (struct usb_device *dev, unsigned long pipe,
        void *data, long len, long *actual_length, long timeout, long flags);
 long (*usb_submit_int_msg) (struct usb_device *dev, unsigned long pipe,
        void *buffer, long transfer_len, long interval);
 long (*usb_disable_asynch) (long disable);
 long (*usb_maxpacket) (struct usb_device *dev, unsigned long pipe);
 long (*usb_get_configuration_no) (struct usb_device *dev, long cfgno);
 long (*usb_get_report) (struct usb_device *dev, long ifnum, unsigned char type,
        unsigned char id, void *buf, long size);
 long (*usb_get_class_descriptor) (struct usb_device *dev, long ifnum,
         unsigned char type, unsigned char id, void *buf,
         long size);
 long (*usb_clear_halt) (struct usb_device *dev, long pipe);
 long (*usb_string) (struct usb_device *dev, long idx, char *buf, long size);
 long (*usb_set_interface) (struct usb_device *dev, long interface, long alternate);
 long (*usb_parse_config) (struct usb_device *dev, unsigned char *buffer, long cfgno);
 long (*usb_set_maxpacket) (struct usb_device *dev);
 long (*usb_get_descriptor) (struct usb_device *dev, unsigned char type,
        unsigned char idx, void *buf, long size);
 long (*usb_set_address) (struct usb_device *dev);
 long (*usb_set_configuration)(struct usb_device *dev, long configuration);
 long (*usb_get_string) (struct usb_device *dev, unsigned short langid,
           unsigned char idx, void *buf, long size);
 struct usb_device * (*usb_alloc_new_device) (void *controller);
 long (*usb_new_device) (struct usb_device *dev);
# 185 "../../../usb_api.h"
};
# 5 "../usb_mouse.c" 2

# 1 "c:\\mint-elf\\m68k-atari-mint-elf-8.1.0\\devkitmint\\devkitmint\\m68k-atari-mint\\include\\mint\\osbind.h" 1 3
# 116 "c:\\mint-elf\\m68k-atari-mint-elf-8.1.0\\devkitmint\\devkitmint\\m68k-atari-mint\\include\\mint\\osbind.h" 3
# 1 "c:\\mint-elf\\m68k-atari-mint-elf-8.1.0\\devkitmint\\devkitmint\\m68k-atari-mint\\include\\mint\\ostruct.h" 1 3
# 11 "c:\\mint-elf\\m68k-atari-mint-elf-8.1.0\\devkitmint\\devkitmint\\m68k-atari-mint\\include\\mint\\ostruct.h" 3

# 23 "c:\\mint-elf\\m68k-atari-mint-elf-8.1.0\\devkitmint\\devkitmint\\m68k-atari-mint\\include\\mint\\ostruct.h" 3

# 23 "c:\\mint-elf\\m68k-atari-mint-elf-8.1.0\\devkitmint\\devkitmint\\m68k-atari-mint\\include\\mint\\ostruct.h" 3
typedef struct {
    long b_free;
    long b_total;
    long b_secsiz;
    long b_clsiz;
} _DISKINFO;


typedef struct {
  unsigned short time;
  unsigned short date;
} _DOSTIME;


typedef struct
{
        unsigned char maxlen;
        unsigned char actuallen;
        char buffer[255];
} _CCONLINE;


typedef struct _dta {
    char dta_buf[21];
    char dta_attribute;
    unsigned short dta_time;
    unsigned short dta_date;
    long dta_size;
    char dta_name[14];
} _DTA;

typedef struct
{
 unsigned hour : 5;
 unsigned minute : 6;
 unsigned second : 5;
 unsigned year : 7;
 unsigned month : 4;
 unsigned day : 5;
} _DATETIME;
# 220 "c:\\mint-elf\\m68k-atari-mint-elf-8.1.0\\devkitmint\\devkitmint\\m68k-atari-mint\\include\\mint\\ostruct.h" 3
typedef struct {
  short recsiz;
  short clsiz;
  short clsizb;
  short rdlen;
  short fsiz;
  short fatrec;
  short datrec;
  short numcl;
  short bflags;
} _BPB;




typedef struct _md {
    struct _md *md_next;
    long md_start;
    long md_length;
    BASEPAGE *md_owner;
} _MD;


typedef struct {
    _MD *mp_free;
    _MD *mp_used;
    _MD *mp_rover;
} _MPB;
# 509 "c:\\mint-elf\\m68k-atari-mint-elf-8.1.0\\devkitmint\\devkitmint\\m68k-atari-mint\\include\\mint\\ostruct.h" 3
typedef struct {
    char *ibuf;
    short ibufsiz;
    volatile short ibufhd;
    volatile short ibuftl;
    short ibuflow;
    short ibufhi;
} _IOREC;


typedef struct {
 char topmode;
 char buttons;
 char xparam;
 char yparam;
 short xmax;
 short ymax;
 short xstart;
 short ystart;
} _PARAM;


typedef struct {
    void (*midivec) (void);
    void (*vkbderr) (void);
    void (*vmiderr) (void);
    void (*statvec) (void *);
    void (*mousevec) (void *);
    void (*clockvec) (void *);
    void (*joyvec) (void *);
    long (*midisys) (void);
    long (*ikbdsys) (void);
    char kbstate;
} _KBDVECS;


typedef struct {
    char *unshift;
    char *shift;
    char *caps;




    char *alt;
    char *altshift;
    char *altcaps;




    char *altgr;

} _KEYTAB;


typedef struct
{
        void *pb_scrptr;
        int pb_offset;
        int pb_width;
        int pb_height;
        int pb_left;
        int pb_right;
        int pb_screz;
        int pb_prrez;
        void *pb_colptr;
        int pb_prtype;
        int pb_prport;
        void *pb_mask;
} _PBDEF;


typedef struct
{
 unsigned short mi_version;
 long mi_magic;
 const char *mi_log2phys;
} META_INFO_2;


typedef struct
{
 unsigned long drivemap;
 char *version;
 long reserved[2];

 META_INFO_2 *info;
} META_INFO_1;






typedef struct
{
 char reserved;
 char red;
 char green;
 char blue;
} _RGB;


typedef struct
{
 short (*Bconstat)();
 long (*Bconin)();
 long (*Bcostat)();
 void (*Bconout)();
 unsigned long (*Rsconf)();
 _IOREC *iorec;
} _MAPTAB;


typedef struct
{
 _MAPTAB *maptab;
 short maptabsize;
} _BCONMAP;


typedef struct
{
 unsigned year:7;
 unsigned month:4;
 unsigned day:5;
 unsigned hour:5;
 unsigned minute:6;
 unsigned second:5;
} _BIOSTIME;



# 117 "c:\\mint-elf\\m68k-atari-mint-elf-8.1.0\\devkitmint\\devkitmint\\m68k-atari-mint\\include\\mint\\osbind.h" 2 3



# 1275 "c:\\mint-elf\\m68k-atari-mint-elf-8.1.0\\devkitmint\\devkitmint\\m68k-atari-mint\\include\\mint\\osbind.h" 3

# 7 "../usb_mouse.c" 2





# 11 "../usb_mouse.c"
typedef u_int8_t uint8_t;
typedef u_int16_t uint16_t;
typedef u_int32_t uint32_t;

# 1 "../mouse_report_desc_parser.h" 1



typedef struct {
 uint16_t reportID;
 uint16_t offset;
 uint16_t size;
 int32_t logicalMin;
 int32_t logicalMax;
} HID_ENTRY;

int32_t mouse_hid_report_descriptor_parser(uint8_t *report_descriptor, uint32_t report_descriptor_len, HID_ENTRY *hid_entries, uint8_t *tempBuffer);
# 16 "../usb_mouse.c" 2
# 42 "../usb_mouse.c"
struct kentry *kentry;

void mouse_poll_thread (void *);
void mouse_poll (PROC * proc, long dummy);
# 60 "../usb_mouse.c"
struct kbdvbase
{
 long midivec;
 long vkbderr;
 long vmiderr;
 long statvec;
 long mousevec;
 long clockvec;
 long joyvec;
 long midisys;
 long ikbdsys;
 short drvstat;

};
typedef struct kbdvbase KBDVEC;

KBDVEC *vector;
static char mouse_packet[6];
void send_packet (long func, char *buf, char *bufend);
void fake_hwint(void);


void send_wheel(short wheel, short wclicks);
extern unsigned long vdi_buttons;
void vdi_btnv(void);
extern void(*old_vdi_btnv)(void);
extern void(*vdi_wheelv)(void);
extern void trap2(void);
extern void(*old_trap2)(void);

struct usb_module_api *api;
# 99 "../usb_mouse.c"
void mouse_int (void);
# 110 "../usb_mouse.c"
static long mouse_ioctl (struct uddif *, short, long);
static long mouse_disconnect (struct usb_device *dev);
static long mouse_probe (struct usb_device *dev, unsigned int ifnum);

static char lname[] = "USB mouse class driver\0";

static struct uddif mouse_uif = {
 0,
 1,
 0,
 lname,
 "mouse",
 0,
 0,
 mouse_probe,
 mouse_disconnect,
 0,
 mouse_ioctl,
 0,
};


struct mse_data
{
 struct usb_device *pusb_dev;
 unsigned char ep_in;
 unsigned char ep_out;
 unsigned char ep_int;
 long *irq_handle;
 unsigned long irqpipe;
 unsigned char irqmaxp;
 unsigned char irqinterval;
 unsigned char report_len;
 char buttons;
 char data[64];
 long move_and_scroll[4];






 HID_ENTRY hid_entries[9];
};

static const HID_ENTRY hid_boot_entries[9] = {
 { 0, 0, 1, 0, 1 },
 { 0, 1, 1, 0, 1 },
 { 0, 2, 1, 0, 1 },
 { 0, 3, 1, 0, 1 },
 { 0, 4, 1, 0, 1 },
 { 0, 8, 8, -128, 127 },
 { 0, 16, 8, -128, 127 },
 { 0, 0, 0, 0, 0 },
 { 0, 0, 0, 0, 0 },
};


static struct mse_data mse_data;






static char clampMouseMove(long *remaining) {
 long ret;
 if (*remaining > 127)
  ret = 127;
 else if (*remaining < -128)
  ret = -128;
 else
  ret = (char)*remaining;
 *remaining -= ret;
 return ret;
}



typedef union {
 short *s;
 void(**f)(void);
} ptr_u;

static void vdi_vex(short op, void(*fnc)(void), void(**old_fnc)(void)) {
 short vdi_contrl[12] = { 0, 0, 0, 0, 0, 0, 0 , 0 , 0, 0, 0, 0 };
 short *vdi_pb[5] = { vdi_contrl,0,0,0,0 };
 vdi_contrl[0] = op;
 *((ptr_u)&vdi_contrl[7]).f = fnc;
 __asm__ volatile (
  "move.l %0, d1\n"
  "	moveq.l #115, d0\n"
  "	trap #2"
  : : "g"(vdi_pb), "r"(op) : "d0", "d1", "d2", "a0", "a1", "a2", "memory"
  );
 *old_fnc = *((ptr_u)&vdi_contrl[9]).f;
}
# 215 "../usb_mouse.c"
static long
mouse_ioctl (struct uddif *u, short cmd, long arg)
{
 return 0;
}
# 229 "../usb_mouse.c"
static long
mouse_disconnect (struct usb_device *dev)
{
 if (dev == mse_data.pusb_dev)
 {
  mse_data.pusb_dev = 
# 234 "../usb_mouse.c" 3
                     (0L)
# 234 "../usb_mouse.c"
                         ;

  (*kentry->vec_proc.wake) (2, (long) &mouse_poll_thread);

 }

 return 0;
}

static long
usb_mouse_irq (struct usb_device *dev)
{
 return 0;
}

void
mouse_int (void)
{
 long i, changed = 0;
 long actlen = 0;
 long r;
 char *p, buttons = 0;

 static char button_bits[] = { 1 << 1, 1 << 0, 1 << 2, 1 << 3, 1 << 4 };

 if (mse_data.pusb_dev == 
# 259 "../usb_mouse.c" 3
                         (0L)
# 259 "../usb_mouse.c"
                             )
  return;
# 269 "../usb_mouse.c"
 r = (*api->usb_bulk_msg) (mse_data.pusb_dev,
       mse_data.irqpipe,
       mse_data.data,
       mse_data.report_len > 64 ? 64 : mse_data.report_len,
       &actlen, 100 * 5, 1);


 if ((r != 0) || (actlen < 3))
  return;
 for (i = 0; i < 5; ++i) {
  if (mse_data.hid_entries[i].size) {
   p = mse_data.data;
   if ((mse_data.hid_entries[i].reportID == 0) || (mse_data.hid_entries[i].reportID == *p++)) {
    u_int16_t currBit = mse_data.hid_entries[i].offset;
    if (p[currBit / 8] & (1 << (currBit % 8)))
     buttons |= button_bits[i];
   }
  }
 }
 changed = mse_data.buttons ^ buttons;
 mse_data.buttons = buttons;
 for (i = 5; i < 9; ++i) {
  if (mse_data.hid_entries[i].size) {
   p = mse_data.data;
   if ((mse_data.hid_entries[i].reportID == 0) || (mse_data.hid_entries[i].reportID == *p++)) {
    u_int16_t currBit = mse_data.hid_entries[i].offset;
    u_int16_t bitsRem = mse_data.hid_entries[i].size;
    u_int32_t bitMask = (1 << 0);
    int32_t value = 0;

    while (bitsRem--) {
     if (p[currBit / 8] & (1 << (currBit % 8)))
      value |= bitMask;
     currBit++;
     bitMask <<= 1;
    }
    if (mse_data.hid_entries[i].logicalMin < 0 || mse_data.hid_entries[i].logicalMax < 0) {

     bitsRem = 32 - mse_data.hid_entries[i].size;
     if (bitsRem > 0) value = (value << bitsRem) >> bitsRem;
    }
    mse_data.move_and_scroll[i - 5] = value;
    if (value) changed |= 1 << (8 + i - 5);
   }
  }
 }
# 339 "../usb_mouse.c"
 if (changed & 0x031F) {
  vdi_buttons = mse_data.buttons & 0x1c;
  mouse_packet[0] = 0xF8 | (mse_data.buttons & 3);
  do {
   mouse_packet[1] = clampMouseMove(&mse_data.move_and_scroll[0]);
   mouse_packet[2] = clampMouseMove(&mse_data.move_and_scroll[1]);
   send_packet(vector->mousevec, mouse_packet, mouse_packet + 3);
  } while (mse_data.move_and_scroll[0] || mse_data.move_and_scroll[1]);
 }
 for (i = 0; i < 2; ++i) {
  if (changed & (0x400 << i)) {
   send_wheel(i, mse_data.move_and_scroll[2+i]);
   mse_data.move_and_scroll[2+i] = 0;
  }
 }

 if (changed) fake_hwint();

}


void
mouse_poll (PROC * proc, long dummy)
{
 (*kentry->vec_proc.wake) (2, (long) &mouse_poll_thread);
}

void
mouse_poll_thread (void *dummy)
{
 p_setpriority(0,0,-20);

 while (mse_data.pusb_dev)
 {
  mouse_int ();
  (*kentry->vec_proc.addroottimeout) (20, mouse_poll, 0);
  (*kentry->vec_proc.sleep) (2, (long) &mouse_poll_thread);
 }

 (*kentry->vec_proc.kthread_exit) (0);
}







__attribute__((used)) static long
mouse_probe (struct usb_device *dev, unsigned int ifnum)
{
 struct usb_interface *iface;
 struct usb_endpoint_descriptor *ep_desc;
 unsigned char *usb_hid_report_descriptor;
 unsigned char *tempBuff;
 long usb_hid_report_descriptor_size;
 int have_bootprotocol = 1;
 int usb_hid_report_descriptor_ok = 0;




 if (mse_data.pusb_dev)
 {
  return -1;
 }

 if (dev == 
# 406 "../usb_mouse.c" 3
           (0L)
# 406 "../usb_mouse.c"
               )
 {
  return -1;
 }

 (*api->usb_disable_asynch) (1);




 iface = &dev->config.if_desc[ifnum];
 if (!iface)
 {
  return -1;
 }

 if (iface->desc.bInterfaceClass != 3)
 {
  return -1;
 }

 if (iface->desc.bInterfaceSubClass != 1)
 {
  have_bootprotocol = 0;

 }

 if (have_bootprotocol && iface->desc.bInterfaceProtocol != 2)
 {
  return -1;
 }

 if (iface->desc.bNumEndpoints != 1)
 {
  return -1;
 }

 ep_desc = &iface->ep_desc[0];
 if (!ep_desc)
 {
  return -1;
 }

 if ((ep_desc->bmAttributes & 0x03) == 3)
 {
  mse_data.ep_int = ep_desc->bEndpointAddress & 0x0f;
  mse_data.irqinterval = ep_desc->bInterval;
 }
 else
 {
  return -1;
 }


 usb_hid_report_descriptor = (unsigned char*)(*kentry->vec_mem.kmalloc)(2048 + mouse_hid_report_descriptor_parser(0, 0, 0, 0), "mouse"":""../usb_mouse.c"",""460");
 if (!usb_hid_report_descriptor) {
  return -1;
 }
 tempBuff = usb_hid_report_descriptor + 2048;


 usb_hid_report_descriptor_size = (*api->usb_get_class_descriptor)(dev, iface->desc.bInterfaceNumber, 0x22, 0, usb_hid_report_descriptor, 2048);

 if (usb_hid_report_descriptor_size > 0) {







  int32_t err;
  if ((err = mouse_hid_report_descriptor_parser(usb_hid_report_descriptor, usb_hid_report_descriptor_size, mse_data.hid_entries, tempBuff)) == 0) {
   short i;
   usb_hid_report_descriptor_ok = 1;
   mse_data.report_len = 8;
   for (i = 0; i < 8; ++i) {
    if (mse_data.hid_entries[i].size) {
     u_int16_t len = (mse_data.hid_entries[i].offset + mse_data.hid_entries[i].size + 7) / 8;
     if (mse_data.hid_entries[i].reportID) ++len;
     if (mse_data.report_len < len)
      mse_data.report_len = len;
    }
   }
  } else {
   ;
   if (have_bootprotocol) {
    ;
    (*kentry->vec_libkern.memcpy)(mse_data.hid_entries, hid_boot_entries, sizeof(hid_boot_entries));
    mse_data.report_len = 8;
   }
  }
 }

 (*kentry->vec_mem.kfree)(usb_hid_report_descriptor, "mouse"":""../usb_mouse.c"",""500");
 if (!(have_bootprotocol | usb_hid_report_descriptor_ok)) {
  return -1;
 }

 mse_data.pusb_dev = dev;

 mse_data.irqinterval = (mse_data.irqinterval > 0) ? mse_data.irqinterval : 255;
 mse_data.irqpipe = ((1L << 30) | (((mse_data.pusb_dev)->devnum << 8) | ((long) mse_data.ep_int << 15) | ((mse_data.pusb_dev)->speed << 26) | (mse_data.pusb_dev)->maxpacketsize) | 0x80);
 mse_data.irqmaxp = (*api->usb_maxpacket) (dev, mse_data.irqpipe);
 dev->irq_handle = usb_mouse_irq;

 (*api->usb_set_protocol)(dev, iface->desc.bInterfaceNumber, usb_hid_report_descriptor_ok);






 (*api->usb_set_idle) (dev, iface->desc.bInterfaceNumber, 0, 0);




 long r = (*kentry->vec_proc.kthread_create) ((*kentry->vec_proc.get_curproc) (), mouse_poll_thread, 
# 524 "../usb_mouse.c" 3
                                                            (0L)
# 524 "../usb_mouse.c"
                                                                , 
# 524 "../usb_mouse.c" 3
                                                                  (0L)
# 524 "../usb_mouse.c"
                                                                      ,
        "mousepoll");

 if (r)
 {
  return 0;
 }


 return 0;
}
# 575 "../usb_mouse.c"
long init (struct kentry *, struct usb_module_api *, long, long);
long
init (struct kentry *k, struct usb_module_api *uapi, long arg, long reason)

{
 long ret;


 kentry = k;
 api = uapi;

 if (check_kentry_version ())
  return -1;


 c_conws ("\033p USB mouse class driver " "FreeMiNT DRIVERS" " \033q\r\n");
 c_conws ("Ported, mixed and shaken by Alan Hourihane.\r\n" "HID Report DescriptorParser\r\n" "    & MWheel-Extension by Armin Diedering. \r\n" "Compiled " "Sep 11 2018" ".\r\n\r\n");
 ;
# 618 "../usb_mouse.c"
 ret = (*api->udd_register) (&mouse_uif);

 if (ret)
 {
  ;
  return 1;
 }

 ;

 vector = (KBDVEC *) 
# 628 "../usb_mouse.c" 3
                    (_KBDVECS*)__extension__ ({ register long retvalue __asm__("d0"); __asm__ volatile ( "movw	%1,sp@-\n\t" "trap	#14\n\t" "addql	#2,sp" : "=r"(retvalue) : "g"((short)(0x22)) : "d1", "d2", "a0", "a1", "a2" , "memory" ); retvalue; })
# 628 "../usb_mouse.c"
                               ;



 vdi_vex(125, vdi_btnv, &old_vdi_btnv);
 old_trap2 = 
# 633 "../usb_mouse.c" 3
            (void (*) (void))__extension__ ({ register long retvalue __asm__("d0"); short _a = (short)((short)(
# 633 "../usb_mouse.c"
            0x88 / 4
# 633 "../usb_mouse.c" 3
            )); long _b = (long) ((long)(
# 633 "../usb_mouse.c"
            trap2
# 633 "../usb_mouse.c" 3
            )); __asm__ volatile ( "movl	%3,sp@-\n\t" "movw	%2,sp@-\n\t" "movw	%1,sp@-\n\t" "trap	#13\n\t" "addql	#8,sp" : "=r"(retvalue) : "g"((short)(0x05)), "r"(_a), "r"(_b) : "d1", "d2", "a0", "a1", "a2" , "memory" ); retvalue; })
# 633 "../usb_mouse.c"
                                   ;
# 655 "../usb_mouse.c"
 return 0;
}
